Bug 655904 - hang/crash on massive kprobing
Summary: hang/crash on massive kprobing
Status: CLOSED UPSTREAM
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel   
(Show other bugs)
Version: 19
Hardware: Unspecified
OS: Unspecified
low
medium
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 831833 655908
TreeView+ depends on / blocked
 
Reported: 2010-11-22 16:52 UTC by Frank Ch. Eigler
Modified: 2013-04-05 16:35 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 655908 (view as bug list)
Environment:
Last Closed: 2013-04-05 16:35:24 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

Description Frank Ch. Eigler 2010-11-22 16:52:28 UTC
A longstanding problem in the linux kernel has been its failure to protect
itself against massive kprobe sessions, such as with systemtap scripts such as:

   probe kernel.function("*") {}

The important thing to note is that systemtap is not required to show
this problem.  "perf probe" can do it, as can the following recipe, which
builds an absolutely minimal kprobes-using kernel module, and applies it
to function entry points (as gleamed form /proc/kallsyms).  (With systemtap,
we can easily place probes into the bodies of functions too, and of course
that crashes even "harder", but let's leave that till later.)

  git clone git://sourceware.org/git/systemtap.git
  cd systemtap/scripts/kprobes_test
  sh gen_code_all.sh
  insmod kprobe_module.ko
  <bang>

There may be multiple causes, such as inadequate __kprobes markup, or
exception handling, or unknown factors.

See also

http://sourceware.org/PR275
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=604453

Comment 1 Chuck Ebbert 2010-12-09 15:53:05 UTC
That's http://sourceware.org/bugzilla/show_bug.cgi?id=2725

Comment 2 Frank Ch. Eigler 2013-01-29 18:35:26 UTC
(Still affects kernel 3.8.0-0.rc4.git5.1

# stap -e 'probe kernel.function("*").call {}' -c 'sleep 1'

restarts my x86-64 vm.)

Comment 3 Fedora End Of Life 2013-04-03 18:43:38 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19

Comment 4 Justin M. Forbes 2013-04-05 16:35:24 UTC
This really needs to be reported and handled upstream


Note You need to log in before you can comment on or make changes to this bug.